.386
.model flat,stdcall
option casemap:none

include     \GeneSys\include\windows.inc
include     \GeneSys\include\kernel32.inc
include     \GeneSys\include\user32.inc
include     \GeneSys\include\gdi32.inc

includelib  \GeneSys\lib\kernel32.lib
includelib  \GeneSys\lib\user32.lib
includelib  \GeneSys\lib\gdi32.lib

.data

ClassName   db 'Shell_TrayWnd',0

.code

start:

    call    main
    invoke  ExitProcess,0

main PROC uses esi

LOCAL hDC:DWORD
LOCAL x:DWORD,y:DWORD
LOCAL x2:DWORD,y2:DWORD
LOCAL tempDC:DWORD,hWnd:DWORD
LOCAL hBmp:DWORD,hOldBmp:DWORD

    invoke  FindWindow,ADDR ClassName,0
    mov     hWnd,eax

    invoke  GetDC,0                                 ; get the DC of desktop
    mov     hDC,eax
    invoke  CreateCompatibleDC,eax                  ; create a DC compatible with hDC
    mov     tempDC,eax
    invoke  GetSystemMetrics,SM_CXSCREEN            ; get the width and height of the screen
    mov     x,eax
    mov     x2,eax
    invoke  GetSystemMetrics,SM_CYSCREEN
    mov     y,eax
    mov     y2,eax
    invoke  CreateCompatibleBitmap,hDC,x,eax        ; create a compatible bitmap
    mov     hBmp,eax
    invoke  SelectObject,tempDC,eax
    mov     hOldBmp,eax
    invoke  BitBlt,tempDC,0,0,x,y,hDC,0,0,SRCCOPY   ; copy the screen to the target DC

    xor     esi,esi

@@:
    invoke  BitBlt,hDC,esi,esi,x,y,hDC,0,0,SRCCOPY
    invoke  BitBlt,hDC,0,esi,x,y,hDC,0,0,SRCCOPY
    invoke  Sleep,50

    add     esi,1
    cmp     esi,30
    jne     @b

@@:
    invoke  BitBlt,hDC,esi,0,x,y,hDC,0,0,SRCCOPY
    invoke  BitBlt,hDC,esi,esi,x,y,hDC,0,0,SRCCOPY
    invoke  Sleep,50

    sub     esi,1
    test    esi,esi
    jnz     @b

    invoke  BitBlt,hDC,0,0,x2,y2,tempDC,0,0,SRCCOPY ; copy the screen to the target DC
    invoke  SelectObject,tempDC,hOldBmp             ; return back the old handle

    invoke  ShowWindow,hWnd,SW_HIDE                 ; redraw the taskbar to display the correct time
    invoke  ShowWindow,hWnd,SW_SHOW

    invoke  DeleteObject,hBmp                       ; return back resources to the OS
    invoke  DeleteObject,hOldBmp
    invoke  DeleteDC,tempDC
    invoke  ReleaseDC,0,hDC

    ret

main ENDP

END start

